
/* Keen Mod v0.2   by Scott M. Sirovy 
   June 5, 1992
*/

#include <stdio.h>

#ifndef SEEK_SET
#define SEEK_SET     0
#endif

#define LIFES        0x7A
#define SHOTS        0x68
#define MAXVAL       0xFF
#define GTEXT        0x08
#define FNAME        "SAVEGAM0.CK4"
#define GCOUNT       24

int main(int argc, char **argv)
{
    FILE *fp;
    char ch[1],
         file_name[13],
         game_text[GCOUNT +1],
         c;

    if (argc != 2)
    {
        fprintf(stderr, "KEEN_MOD v0.2 - Scott M. Sirovy\n"
                        "     Purpose: to give your keen game maximum lives "
                        "and maximum ammo.\n"
                        "syntax:  keen_mod <game #>\n"
                        "     <game #> is the number of the file to be "
                        "modified (0 to 5).\n");
        exit(1);
    }

    strcpy(file_name, FNAME);
    file_name[7] = argv[1][0];
    ch[0] = MAXVAL;

    fp = fopen(file_name, "r+b");
    if (fp ==NULL)
    {
        fprintf(stderr, "error: can not open file '%s'.\n", file_name);
        exit(2);
    }

    if (fseek(fp, GTEXT, SEEK_SET) != 0)
    {
        fprintf(stderr, "seek error: file '%s'.\n", file_name);
        exit(3);
    }

    if (fread(game_text, 1, GCOUNT, fp) != GCOUNT)
    {
        fprintf(stderr, "read error: file '%s'.\n", file_name);
        exit(4);
    }

    fprintf(stdout, "Modify game '%s'? ", game_text);
    c = getchar();
    if ((c != 'y') && (c != 'Y'))
    {
        fclose(fp);
        fprintf(stdout, "\nAborting...\n");
        exit(0);
    }

    if (fseek(fp, LIFES, SEEK_SET) != 0)
    {
        fprintf(stderr, "\nseek error: file '%s'.\n", file_name);
        exit(3);
    }

    if (fwrite(ch, 1, 1, fp) != 1)
    {
        fprintf(stderr, "\nwrite error: file '%s'.\n", file_name);
        exit(4);
    }

    if (fseek(fp, SHOTS, SEEK_SET) != 0)
    {
        fprintf(stderr, "\nseek error: file '%s'.\n", file_name);
        exit(3);
    }

    if (fwrite(ch, 1, 1, fp) != 1)
    {
        fprintf(stderr, "\nwrite error: file '%s'.\n", file_name);
        exit(4);
    }

    fclose(fp);
    fprintf(stdout, "\nDone.\n");
    return (0);
}

